local MASQUE = LibStub("Masque", true);
local buttongroupItems = nil;
    
local texture = "Interface\\PLAYERACTIONBARALT\\GENERICWOW";

function CleanUI_InitMiniMap()

    if (MASQUE) then
        buttongroupDigsite = MASQUE:Group("CleanUI", "DigsiteActions");
    end

    CleanUserData.scaleMiniMap = CleanUserData.scaleMiniMap or 1.1

    CleanUI_MiniMapHookEvents();
    CleanUI_RegisterMiniMapEvents();
    
    CleanUI_ChangeMiniMap();
    CleanUI_ScaleMiniMap();
    
    CleanuUI_ChangeMiniMapArt();
end

function CleanUI_RegisterMiniMapEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");
    --frame:RegisterEvent("MERCHANT_SHOW");
    --frame:RegisterEvent("BANKFRAME_OPENED");
    --frame:RegisterEvent("BAG_UPDATE");

    frame:HookScript("OnEvent", CleanUI_MiniMapOnEvent);
    frame:HookScript("OnUpdate", CleanUI_MiniMapOnUpdate);
end

function CleanUI_MiniMapOnEvent(self, event, ...)

    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "..." ) then
        end
    end

    --if (event == "MERCHANT_SHOW") then
        --CleanUI_MerchantShow();
    --end
end

local UPDATE_WAIT = 0.5;
local _WaitTimeSinceLast = 0;
function CleanUI_MiniMapOnUpdate(self, elapsed)
    if (_WaitTimeSinceLast <= 0) then
        CleanUI_CheckResearchSite();
        CleanUI_UpdateMiniMapCoords();
        _WaitTimeSinceLast = UPDATE_WAIT;
    else
        _WaitTimeSinceLast = _WaitTimeSinceLast - elapsed;
    end
end

function CleanUI_MiniMapHookEvents()
end

function CleanUI_SetMiniMapScale(scale)
    if (scale and scale >= 0.5 and scale <= 2) then
        CleanUserData.scaleMiniMap = scale
        CleanUI_ScaleMiniMap() 
    else
        DEFAULT_CHAT_FRAME:AddMessage("scale: from 0.5 to 2.0", 1.0, 0, 0, 1, 10);
    end
end

function CleanUI_ScaleMiniMap()    
    MinimapCluster:SetScale(CleanUserData.scaleMiniMap);
end

function CleanUI_ChangeMiniMap()
    -- Koordinaten
    local coords = Minimap:CreateFontString("CUIWorldMiniMapFrameCoords", "ARTWORK");
    coords:SetFontObject("CuiFont_ExtraSmall");
    coords:SetWidth(Minimap:GetWidth());
    coords:SetHeight(10);
    coords:ClearAllPoints();
    coords:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 0, 0);
    coords:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 0, 0);
    coords:SetJustifyH("CENTER");
    coords:SetText("Hallo");
end

function CleanuUI_ChangeMiniMapArt()
    Minimap:SetMaskTexture("Interface\\AddOns\\CleanUI\\skins\\minimap\\masktexture");
    MinimapBorder:Hide();
    MinimapBorderTop:Hide();
    
    Minimap:ClearAllPoints();
    Minimap:SetPoint("TOP", MinimapCluster, "TOP", -5, -25);
    
    -- zone text

    MinimapZoneTextButton:ClearAllPoints();
    MinimapZoneTextButton:SetPoint("TOPLEFT", MinimapCluster, "TOPLEFT", 19, -8);
    MinimapZoneTextButton:SetPoint("BOTTOMRIGHT", MinimapCluster, "TOPRIGHT", -29, -25);
    
    -- world map button
    
    MiniMapWorldMapButton:SetNormalTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapWorldMapButton:SetPushedTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapWorldMapButton:SetHighlightTexture("Interface\\worldmap\\UI-World-Icon");
    
    MiniMapWorldMapButton:GetNormalTexture():SetTexCoord(0, 1, 0, 1);
    MiniMapWorldMapButton:GetPushedTexture():SetTexCoord(0, 1, 0, 1);
    MiniMapWorldMapButton:GetHighlightTexture():SetTexCoord(0, 1, 0, 1);
    
    MiniMapWorldMapButton:SetSize(32, 32);
    MiniMapWorldMapButton:SetPoint("TOPRIGHT", -2, 18);
    
    -- game time frame
    
    GameTimeFrame:SetSize(32, 32);
    
    GameTimeFrame:ClearAllPoints();
    GameTimeFrame:SetPoint("TOP", MiniMapWorldMapButton, "BOTTOM", 0, -2);
    
    -- tracking button
    
    MiniMapTracking:SetSize(32, 32);
    
    MiniMapTracking:ClearAllPoints();
    MiniMapTracking:SetPoint("TOP", GameTimeFrame, "BOTTOM", 0, -2);  
    
    -- voice chat
    
    MiniMapVoiceChatFrame:SetSize(32, 32);
    
    MiniMapVoiceChatFrame:ClearAllPoints();
    MiniMapVoiceChatFrame:SetPoint("TOP", MiniMapTracking, "BOTTOM", 0, -2);  
    
    -- mail frame
    
    MiniMapMailFrame:SetSize(32, 32);
    
    MiniMapMailFrame:ClearAllPoints();
    MiniMapMailFrame:SetPoint("TOP", MiniMapVoiceChatFrame, "BOTTOM", 0, -2);    
    
    -- time manager
    
    TimeManagerClockButton:ClearAllPoints();
    --TimeManagerClockButton:SetPoint("TOP", MinimapCluster, "BOTTOM", -10, 26);
    
    TimeManagerClockButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 1.5, -3.5);
    CleanUI_ReplaceTextureWith("ClockBackground", TimeManagerClockButton, nil);
    TimeManagerFrame:ClearAllPoints();
    TimeManagerFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 150);
    
    TimeManagerClockButton:SetSize(51, 28.25);
    
    CleanUI_SetBackdrop(TimeManagerClockButton, true, false, nil, nil, 0, 5, 2, 0);
    
    -- recording button
    
    --MiniMapRecordingButton:ClearAllPoints();
    --MiniMapRecordingButton:SetPoint("LEFT", TimeManagerClockButton, "RIGHT", 0, 0);
    
    -- landing page 
    GarrisonLandingPageMinimapButton:ClearAllPoints();
    GarrisonLandingPageMinimapButton:SetScale(0.75);
    GarrisonLandingPageMinimapButton:SetPoint("TOP", MinimapCluster, "BOTTOMRIGHT", -50, 34);
    
    -- queue status button
    QueueStatusMinimapButton:ClearAllPoints();
    QueueStatusMinimapButton:SetScale(1.2);
    QueueStatusMinimapButton:SetPoint("TOP", MinimapCluster, "BOTTOMLEFT", 20, 22);
    QueueStatusMinimapButtonBorder:Hide();
    
    -- instance difficulty
    MiniMapInstanceDifficulty:SetPoint("TOPLEFT", 18, -20);
    GuildInstanceDifficulty:SetPoint("TOPLEFT", 18, -20);
    MiniMapChallengeMode:SetPoint("TOPLEFT", 24, -25);
    
    -- change icons
    
    WorldMapFrame.BorderFrame.portrait:SetTexture("Interface\\worldmap\\UI-World-Icon");
    MiniMapMailIcon:SetTexture("Interface\\mailframe\\mail-icon");
    
    -- border
    
     local cuiArtFrame = _G["CleanUIMinimapArtFrame"];
    if (not cuiArtFrame) then
        cuiArtFrame = CreateFrame("Frame", "CleanUIMinimapArtFrame", MinimapCluster);
    end

    cuiArtFrame:SetParent(MinimapCluster);
    CleanUIMinimapArtFrame:SetPoint("TOPLEFT", MinimapCluster, "TOPLEFT", 12, -1);
    CleanUIMinimapArtFrame:SetPoint("BOTTOMRIGHT", MinimapCluster, "BOTTOMRIGHT", -23, 24);
    cuiArtFrame:SetFrameStrata("BACKGROUND");
    
    cuiArtFrame:SetBackdrop( {
            bgFile = nil,
            edgeFile = "Interface\\AddOns\\CleanUI\\skins\\minimap\\minimap-border",
            tile = true, tileSize = 32, edgeSize = 8.5,
            insets = { left = 5, right = 5, top = 5, bottom = 5 }
        });
    
    if (not cuiArtFrame.background) then
        cuiArtFrame.background = cuiArtFrame:CreateTexture("ARTWORK");
        CleanUIMinimapArtFrame.background:SetPoint("TOPLEFT", CleanUIMinimapArtFrame, "TOPLEFT", 8, -3);
        CleanUIMinimapArtFrame.background:SetPoint("BOTTOMRIGHT", CleanUIMinimapArtFrame, "BOTTOMRIGHT", -8, 3);
        cuiArtFrame.background:SetTexture(texture);
        cuiArtFrame.background:SetTexCoord(0.0, 1.0, 0.1757, 0.3555);
    end
    
    if (not cuiArtFrame.topline) then
        cuiArtFrame.topline = cuiArtFrame:CreateTexture("ARTWORK");
        cuiArtFrame.topline:SetSize(100, 4);
        cuiArtFrame.topline:SetParent(Minimap);
        cuiArtFrame.topline:SetPoint("TOPLEFT", cuiArtFrame, "TOPLEFT", 8, -22);
        cuiArtFrame.topline:SetPoint("TOPRIGHT", cuiArtFrame, "TOPRIGHT", -8, -26);
        cuiArtFrame.topline:SetTexture("Interface\\TradeSkillFrame\\UI-TradeSkill-SkillBorder");
        cuiArtFrame.topline:SetTexCoord(0.1, 1.0, 0.0, 0.25);
    end
    
    if (not cuiArtFrame.topleftborder) then
        cuiArtFrame.topleftborder = cuiArtFrame:CreateTexture("HIGHLIGHT");
        cuiArtFrame.topleftborder:SetParent(Minimap);
        cuiArtFrame.topleftborder:SetPoint("TOPLEFT", cuiArtFrame, "TOPLEFT", 0, 1);
        cuiArtFrame.topleftborder:SetPoint("BOTTOMRIGHT", cuiArtFrame, "TOPLEFT", 18, -22);
        cuiArtFrame.topleftborder:SetTexture(texture);
        cuiArtFrame.topleftborder:SetTexCoord(0.2402, 0.3027, 0.7910, 0.8710);
    end
    
    if (not cuiArtFrame.toprightborder) then
        cuiArtFrame.toprightborder = cuiArtFrame:CreateTexture("HIGHLIGHT");
        cuiArtFrame.toprightborder:SetParent(Minimap);
        cuiArtFrame.toprightborder:SetPoint("TOPLEFT", cuiArtFrame, "TOPRIGHT", -18, 1);
        cuiArtFrame.toprightborder:SetPoint("BOTTOMRIGHT", cuiArtFrame, "TOPRIGHT", 0, -22);
        cuiArtFrame.toprightborder:SetTexture(texture);
        cuiArtFrame.toprightborder:SetTexCoord(0.3027, 0.2402, 0.7910, 0.8710);
    end
    
    if (not cuiArtFrame.bottomleftborder) then
        cuiArtFrame.bottomleftborder = cuiArtFrame:CreateTexture("HIGHLIGHT");
        cuiArtFrame.bottomleftborder:SetParent(Minimap);
        cuiArtFrame.bottomleftborder:SetPoint("TOPLEFT", cuiArtFrame, "BOTTOMLEFT", 0, 22);
        cuiArtFrame.bottomleftborder:SetPoint("BOTTOMRIGHT", cuiArtFrame, "BOTTOMLEFT", 18, -1);
        cuiArtFrame.bottomleftborder:SetTexture(texture);
        cuiArtFrame.bottomleftborder:SetTexCoord(0.2402, 0.3027, 0.8710, 0.7910);
    end
    
    if (not cuiArtFrame.bottomrightborder) then
        cuiArtFrame.bottomrightborder = cuiArtFrame:CreateTexture("HIGHLIGHT");
        cuiArtFrame.bottomrightborder:SetParent(Minimap);
        cuiArtFrame.bottomrightborder:SetPoint("TOPLEFT", cuiArtFrame, "BOTTOMRIGHT", -18, 22);
        cuiArtFrame.bottomrightborder:SetPoint("BOTTOMRIGHT", cuiArtFrame, "BOTTOMRIGHT", 0, -1);
        cuiArtFrame.bottomrightborder:SetTexture(texture);
        cuiArtFrame.bottomrightborder:SetTexCoord(0.3027, 0.2402, 0.8710, 0.7910);
    end
end

function CleanUI_UpdateMiniMapCoords()
    local player_x, player_y = CleanUI_GetPlayerMapPosition();
    local output = player_x.."|cffffffff/|r"..player_y;
    
    CUIWorldMiniMapFrameCoords:SetText(output);
end

function CleanUI_CheckResearchSite()
    local button = _G['CUI_DigsiteSurvey'];
    if (not button) then
        button = CreateFrame("Button", "CUI_DigsiteSurvey", UIParent, "ActionButtonTemplate");
        
        local spellId = 80451;
        local spell = GetSpellInfo(spellId);
    
        button:SetAttribute("type", "spell");
        button:SetAttribute("spell", spell);
        button:SetAttribute("spellId", spellId);
    
        local itemTexture = GetSpellTexture(spellId);
        button.icon:SetTexture(itemTexture);
        
        button:HookScript("OnEnter", CleanUI_DigsiteSurvey_MouseOver);
        button:HookScript("OnLeave", CleanUI_DigsiteSurvey_MouseOut);  
        
        button:SetScale(1.2);
        
        buttongroupDigsite:AddButton(button);
        
        UIPARENT_MANAGED_FRAME_POSITIONS["CUI_DigsiteSurvey"] = {baseY = true, yOffset = 100, bottomEither = actionBarOffset, overrideActionBar = overrideActionBarTop, petBattleFrame = petBattleTop, bonusActionBar = 1, pet = 1, watchBar = 1, tutorialAlert = 1, playerPowerBarAlt = 1, extraActionBarFrame = 1, ZoneAbilityFrame = 1, castingBar = 1};
    end
    
    if (button:IsVisible() and CleanUISavedVariables.noDigsiteButton) then
        button:Hide();
        return;
    end
    
    
    if (CanScanResearchSite()) then
        button:Show();
    else
        button:Hide();
    end
    
    UIParent_ManageFramePositions();
end

function CleanUI_DigsiteSurvey_MouseOver(button)

    local spellid = button:GetAttribute("spellId");

    GameTooltip_SetDefaultAnchor(GameTooltip, button);
    GameTooltip:SetSpellByID(spellid);

    GameTooltip:AppendText("");
end

function CleanUI_DigsiteSurvey_MouseOut(button)
    GameTooltip:Hide();
end
